m = Map("ipsec","")
luci.sys.exec("mkdir -p /tmp/ipsec")
local p = m:section( SimpleSection )
p.template = "vpn/ipsec_pg"

a=arg[1]
if not a then
local val=1
x = uci.cursor()
local match=false
local available=false
x:foreach("ipsec", "ipsec", function(s)
  if not available then
    for key, value in pairs(s) do
      if not match and not available and key==".name" then
        y = uci.cursor()
        y:foreach("ipsec", "ipsec", function(t)
          if not match then
            for key1, value1 in pairs(t) do
              if key1==".name" and tostring(value1) == "IPSEC"..val then
                match=true
                break
              end
            end
          end
        end
        )
        if not match then
          available=true
        else
          val=val+1
        end
      end
      if available then
        break
      end
      match=false
    end
  end
end
)
a="IPSEC"..val
cmd="echo "..val.." "..a.." >> /tmp/testss"
luci.sys.exec(cmd)
x:set("ipsec",tostring(a),"ipsec")
x:set("ipsec",tostring(a),"conn",tostring(a))
x:commit("ipsec")
luci.http.redirect(luci.dispatcher.build_url("admin/services/VPN/IPSEC_SETTING_g_to_g", a))
end

s=m:section(NamedSection,a,"ipsec",nil)
s.anonymous = true
s.addremove = false
   

s:tab("general",  translate("General Settings"))                                                                                               
s:tab("advanced",  translate("Advanced Settings"))

--                                     
--
c = s:taboption("general",Value, "conn", "Profile Name")                         
c.datatype="hostname"
c.datatype="datachk"
c.rmempty=false

proto=s:taboption("general",ListValue,"proto","ProtoType")                                 
proto:value("ipsec_g_to_g","Gateway to Gateway")                                           
proto.default="ipsec_g_to_g"

s:taboption("general", Flag, "enable", translate ("Enable"))

--act=s:taboption("general", ListValue, "action", translate ("Action"))
--act:value("respond", "Respond Only")
--act:value("initiate", "Initiate")
--act.default = "initiate"


a = s:taboption("general",Value, "serverip", "Remote IPSEC Gateway")
a.datatype="host"

e = s:taboption("general",Value, "rightsubnet", "Remote Address")     
e.placeholder="x.x.x.x/x"
e.datatype="ipprfx"


e=s:taboption("general",Value, "rightid", "Remote ID")
--e.rmempty=false


iface = s:taboption("general", ListValue, "method", translate("Method"))
iface:value("Static","Static")
iface:value("Auto","Auto")

e=s:taboption("general", ListValue, "route", "Route") 
e:depends({method="Static"}) 
e:value("wan","Wan")                                                                                                                    
e:value("wwan","Wifi")                                                                                                                        
e:value("cellular","Cellular")

e=s:taboption("general", ListValue, "policy", "Policy")          
e:depends({method="Auto"})       
polcy=luci.sys.exec("mwan3 policies | grep Policy | awk '{print$2}' | cut -d ':' -f1")                                                  
for val in polcy:gmatch("(%S+)")   do
	e:value(val,val)
end

inter = s:taboption("general", DummyValue, "interface", "Interface") 
ifc=luci.sys.exec("mwan3 interfaces | grep -v -e '^$' | grep -v pptp | grep -v status | grep -v openvpn | awk '{print$2}'")                                                                                                            
i=1
for val in ifc:gmatch("(%S+)")   do                                                                                                     
	e = s:taboption("general", DummyValue, "leftaddr"..i, "Address")                                                                  
	e.value=luci.sys.exec("ifstatus %q |  grep -A2 ipv4-address |grep -e \"\"address\"\" | cut -d: -f2 | cut -d '\"' -f2 | cut -d[ -f2  " % val)
	e:depends({interface=val})                                                                                                                  
	i=i+1                                                                                                                                                                                                                                                                              
end 

e = s:taboption("general",Value, "leftsubnet", "Local Address")        
e.placeholder="x.x.x.x/x"
e.datatype="ipprfx"

b = s:taboption("general",Value, "user","Local ID")                   

l = s:taboption("general",ListValue, "keymode", translate("Key Mode"))             
l:value("psk","Pre Shared Key")                                                     
l:value("rsa","RSA")                                                                
l.default = "psk"

l = s:taboption("general",Value, "key", "Preshared-Key")                            
l.password = true                                                                   
l:depends({keymode="psk"}) 

ca = s:taboption("general", FileUpload, "cert", translate("Cert."), "")
ca:depends({keymode="rsa"})

ca = s:taboption("general", FileUpload, "ckey", translate("Key"), "")
ca:depends({keymode="rsa"})

ca = s:taboption("general", FileUpload, "ca_cert", translate("CA Cert."), "")
ca:depends({keymode="rsa"})


w = s:taboption("general",Value, "watchdog_ip", "Single hop IP for watchdog.")  
w.datatype="ip4addr"
w.rmempty="false"

wt = s:taboption("general",ListValue,"monitored","Monitor interface ping failure.")
wt:value("0","No")
wt:value("1","Yes")
wt.default="0"

o = s:taboption("general", DummyValue,"","")
o.template = "vpn/ipsec"

--
--

--h = s:taboption("advanced",ListValue, "encap", translate("Encap Protocol"))
--h:value("any","Any")                                              
--h:value("esp","ESP")                                              
--h:value("ah","AH")                                                
--h.default = "any"                                                 


--j = s:taboption("advanced",ListValue, "ikemod", translate("IKE Mode"))          
--j:value("any","Any")                                              
--j:value("main","Main")                                            
--j:value("aggressive","Aggressive")                                
--j.default = "any"                                                 

j = s:taboption("advanced",ListValue, "ikemod", translate("IKE Mode"))
j:value("main","Main")
j:value("aggressive","Aggressive")
j.default = "main"


k = s:taboption("advanced",ListValue, "ex", translate("Key Exchange"))            
k:value("ikev1","IKEV1")                                                                        
k:value("ikev2","IKEV2")                                                                      
k.default = "ikev1"  

k = s:taboption("advanced",ListValue, "ikeencrypt", translate("IKE Encryption"))
k:value("any","Any")                                                  
k:value("aes","AES")                                                  
k:value("aes128","AES-128")                                          
k:value("aes192","AES-192")                                          
k:value("aes256","AES-256")                                          
k:value("3des","3DES")                                                
k:value("des","DES") 
k.default = "any"                                                     

l = s:taboption("advanced",ListValue, "ikehash", translate("IKE Hash"))             
l:value("any","Any")
l:value("md5","MD5")
l:value("sha1","SHA1")
l:value("sha2","SHA2")                                                
l.default = "any"                                                    


l = s:taboption("advanced",ListValue, "dhgroup1", translate("DH Group"))             
l:value("any","Any")                                                  
l:value("modp768","Group1(768)")                                       
l:value("modp1024","Group2(1024)")                                      
l:value("modp1536","Group5(1536)")                                      
l:value("group14","Group14(2048)")                                    
l:value("group15","Group15(3072)")                                    
l:value("group16","Group16(4096)")                                    
l:value("group17","Group15(6144)")                                    
l:value("group18","Group16(8192)")                                    
l.default = "any"                                                     

k = s:taboption("advanced",ListValue, "ipsecencrypt", translate("IPsec Encryption"))
k:value("any","Any")                                                  
k:value("aes","AES")                                                  
k:value("aes128","AES-128")                                          
k:value("aes192","AES-192")                                          
k:value("aes256","AES-256")                                          
k:value("3des","3DES")                                                
k:value("des","DES")                                       
k.default = "any" 

l = s:taboption("advanced",ListValue, "ipsechash", translate("IPsec Hash"))         
l:value("any","Any")
l:value("md5","MD5")
l:value("sha1","SHA1")
l:value("sha2","SHA2")                                                   
l.default = "any"                                                    


l = s:taboption("advanced",ListValue, "dhgroup2", translate("DH Group"))             
l:value("any","Any")                                                  
l:value("modp768","Group1(768)")                                       
l:value("modp1024","Group2(1024)")                                      
l:value("modp1536","Group5(1536)")                                      
l:value("group14","Group14(2048)")                                    
l:value("group15","Group15(3072)")                                    
l:value("group16","Group16(4096)")                                    
l:value("group17","Group15(6144)")                                    
l:value("group18","Group16(8192)")                                    
l.default = "any"                                                     

a=s:taboption("advanced",Value, "dpdkeep", "DPD Keep Alive Time")         
a.datatype="integer"           
a=s:taboption("advanced",Value, "dpdtime", "DPD Timeout")                             
a.datatype="integer"           
a=s:taboption("advanced",Value, "ikereykey","Ike Reykey Time")                        
a.datatype="integer"           
a=s:taboption("advanced",Value, "salife","SA Life Time ")                             
a.datatype="integer"           

l = s:taboption("advanced",ListValue, "dpdaction", translate("DPD Action"))         
l:value("none","None")                                                
l:value("clear","Clear") 
l:value("hold","Hold")                                                              
l:value("restart","Restart")                                                        
l.default = "none"  


o = s:taboption("advanced", DummyValue,"","")                                                
o.template = "vpn/ipsec"                                                                    

return m
